|
|
@@ -0,0 +1,64 @@
|
|
|
+#!/bin/sh
|
|
|
+set -e
|
|
|
+
|
|
|
+TESTDIR=$(readlink -f $(dirname $0))
|
|
|
+. $TESTDIR/framework
|
|
|
+
|
|
|
+setupenvironment
|
|
|
+configarchitecture 'native'
|
|
|
+
|
|
|
+insertpackage 'unstable' 'unrelated' 'all' '1.0' 'stable'
|
|
|
+insertsource 'unstable' 'unrelated' 'all' '1.0' 'stable'
|
|
|
+
|
|
|
+echo 'ni ni ni' > aptarchive/knights
|
|
|
+
|
|
|
+setupaptarchive
|
|
|
+changetowebserver -o 'aptwebserver::overwrite::.*::filename=/knights'
|
|
|
+
|
|
|
+msgtest 'Acquire test file from the webserver to check' 'overwrite'
|
|
|
+echo '601 Configuration
|
|
|
+Config-Item: Acquire::http::DependOnSTDIN=0
|
|
|
+
|
|
|
+600 Acquire URI
|
|
|
+URI: http://localhost:8080/holygrail
|
|
|
+Filename: knights-talking
|
|
|
+' | http >/dev/null 2>&1 && msgpass || msgfail
|
|
|
+testfileequal knights-talking 'ni ni ni'
|
|
|
+
|
|
|
+ensure_n_canary_strings_in_dir() {
|
|
|
+ local DIR="$1"
|
|
|
+ local CANARY_STRING="$2"
|
|
|
+ local EXPECTED_N="$3"
|
|
|
+
|
|
|
+ msgtest "Testing in $DIR for $EXPECTED_N canary" "$CANARY_STRING"
|
|
|
+ local N=$(grep "$CANARY_STRING" $DIR/* 2>/dev/null |wc -l )
|
|
|
+ test "$N" = "$EXPECTED_N" && msgpass || msgfail "Expected $EXPECTED_N canaries, got $N"
|
|
|
+}
|
|
|
+
|
|
|
+LISTS='rootdir/var/lib/apt/lists'
|
|
|
+rm -rf rootdir/var/lib/apt/lists
|
|
|
+msgtest 'Got expected NODATA failure in' 'apt-get update'
|
|
|
+aptget update -qq 2>&1 | grep -q 'E: GPG error.*NODATA' && msgpass || msgfail
|
|
|
+
|
|
|
+ensure_n_canary_strings_in_dir $LISTS 'ni ni ni' 0
|
|
|
+testequal 'partial' ls $LISTS
|
|
|
+
|
|
|
+# and again with pre-existing files with "valid data" which should remain
|
|
|
+for f in Release Release.gpg main_binary-amd64_Packages main_source_Sources; do
|
|
|
+ echo 'peng neee-wom' > $LISTS/localhost:8080_dists_stable_${f}
|
|
|
+done
|
|
|
+
|
|
|
+msgtest 'Got expected NODATA failure in' 'apt-get update'
|
|
|
+aptget update -qq 2>&1 | grep -q 'E: GPG error.*NODATA' && msgpass || msgfail
|
|
|
+
|
|
|
+ensure_n_canary_strings_in_dir $LISTS 'peng neee-wom' 4
|
|
|
+ensure_n_canary_strings_in_dir $LISTS 'ni ni ni' 0
|
|
|
+
|
|
|
+# and now with a pre-existing InRelease file
|
|
|
+echo 'peng neee-wom' > $LISTS/localhost:8080_dists_stable_InRelease
|
|
|
+rm -f $LISTS/localhost:8080_dists_stable_Release $LISTS/localhost:8080_dists_stable_Release.gpg
|
|
|
+msgtest 'excpected failure of' 'apt-get update'
|
|
|
+aptget update -qq 2>&1 | grep -q 'E: GPG error.*NODATA' && msgpass || msgfail
|
|
|
+
|
|
|
+ensure_n_canary_strings_in_dir $LISTS 'peng neee-wom' 3
|
|
|
+ensure_n_canary_strings_in_dir $LISTS 'ni ni ni' 0
|